import sys
import time
import threading
import fnmatch
from queue import Queue
from pynovatec.events import EventListener, Events

from pynovatec.events import EventPost, EventRegisterListener,EventUnregisterListener,EventQueueShutdown


class MachineQCEvents(Events):
    event_name='test'
    def __init__(self,data,*args,**kwargs):                    
        new_data = {
            'event_name':self.event_name,
            'data': data 
        }
        super().__init__(new_data,*args,**kwargs) 

class MachineQCBatchCollectionComplete(MachineQCEvents): 
    def __init__(self,*args,**kwargs):
        self.event_name='batch_collection_complete' 
        super().__init__(*args,**kwargs) 

class MachineQCComplete(MachineQCEvents): 
    def __init__(self,*args,**kwargs):
        self.event_name='machineqc_complete' 
        super().__init__(*args,**kwargs) 

class MachineQCShutdown(MachineQCEvents): 
    def __init__(self,*args,**kwargs):
        self.event_name='machineqc_shutdown' 
        super().__init__(*args,**kwargs) 

class MachineQCInit(MachineQCEvents): 
    def __init__(self,*args,**kwargs):
        self.event_name='machineqc_init' 
        super().__init__(*args,**kwargs) 

class MachineQCError(MachineQCEvents): 
    def __init__(self,*args,**kwargs):
        self.event_name='machineqc_error' 
        super().__init__(*args,**kwargs) 

class MachineQCListener(EventListener):                            
    def __init__(self,*args,**kwargs):                                   
        super().__init__(*args,**kwargs)                                
        self.events.append(MachineQCEvents)                    
                                                          
    def handle(self,msg):                                 
        print("QC Listener run: ",msg.data)                  
                                                          
                                                          
