from pathlib import Path
import simplejson as json
from qc_computation.ac_vac_qc_analytics import main_output_qc,qc_init
from pyanalytics_lib import JsonDataStore

def read_config(config_file, default_config):
    if config_file is not None:
        print("Updating configuration details from ",Path(config_file).absolute(),"...")
        with open(config_file) as f:
            json_config = json.load(f)
        #print("config: ",config)
        #print("json config: ",json_config)
        default_config.update(json_config)
        print("Success: Configuration details updated")
        #print("new config: ",config)
    return default_config



def analytics_init(env_info):
    qc_init(env_info)
    pass

def zmq_send_json(a,b):
    JsonDataStore.zmq_send_json(a,b)

def zmq_init():
    pass


batch_count=0

def main_output(input_json):
    global batch_count

    print("MAIN OUTPUT: ")
    #print(json.dumps(input_json,indent=4))

    input_json['header']['group']='qc'
    input_json['header']['qc_profile'] = {}                               
    input_json['header']['qc_profile']['flagStateCount'] = 0
    #input_json['header']['qc_profile']['flagStateCount'] = batch_count	 # This makes it reset every time with batch_count incrementing..

    batch_count += 1
    return main_output_qc(input_json)


config_info = {
    "write_pumpsense_output_json":True
    
}

output_json_folder_str="/tmp/qc/output_json"
output_json_folder=Path(output_json_folder_str)

def store_output_json(final_output):                                                                 
    output_json_write=config_info.get("write_pumpsense_output_json",False)                           
                                                                                                     
    if output_json_write:                                                                            
                                                                                                                                                                                                                                                  
        if not output_json_folder.is_dir():                                                          
            output_json_folder.mkdir(parents=True)                                                                                                            
                                                                                                                                                              
        file_name=f"{final_output['header']['timestamp']}_{final_output['header']['machineId']}_output.json"                                                  
        output_json_file=output_json_folder.joinpath(file_name)                                                                                               
                                                                                                                                                              
        with open(output_json_file,"w") as f:                                                                                                                 
            json.dump(final_output,f,indent=4,ignore_nan=True)                                                                                                
            print("Success: Output JSON written successfully")                 

