
from threading import Lock


class LockingList(list):

    def __init__(self):
        self.mutex = Lock()
    def acquire(self):
        self.mutex.acquire()
    
    def release(self):
        self.mutex.release()

    def append(self,value):
        self.acquire()
        super().append(value)
        self.release()

    def locked(self):
        return self.mutex.locked()


