import zmq
import simplejson as json

class ZmqSender:
    def __init__(self, connect_string,language="python",options={}):
        self.connect_string = connect_string 
        self.language=language
        self.start_connection()

    def start_connection(self):
        context_jsonsender = zmq.Context()
        self.socket = context_jsonsender.socket(zmq.PUSH)
        self.socket.connect(self.connect_string)

    def send_json_r_dict(self,send_type,filename,data):
        socket_string=f"{self.language}~~{send_type}~~{filename}~~{json.dumps(data,ignore_nan=True)}"
        self.socket.send_string(socket_string)
    
    def send_json_r_string(self,send_type,filename,data):
        socket_string=f"{self.language}~~{send_type}~~{filename}~~{data}"
        self.socket.send_string(socket_string)

    def send_raw(self,data):
        self.socket.send_string(data)
    
    def send_dict_as_json(self,data):
        self.socket.send_string(json.dumps(data,ignore_nan=True))

    def send_batch_dict(self,batch_duration,data):
        input_json_new = json.dumps(data,ignore_nan=True)
        self.socket.send_string(str(batch_duration) + '~~' + input_json_new)
    
    def send_batch_string(self,batch_duration,data):
        self.socket.send_string(str(batch_duration) + '~~' + data)

        pass
