import glob
import os
from pygaugelib.api_processing_2 import Gauge_Rule_Extraction


###################################################################################################
#                           Data Processing After Receiving Json Files
###################################################################################################

def fetch_gauge_rule_list(machine_id,json_details_path=None):
    if not json_details_path:
        return None
    #machine_id = json_parsed["header"]["machineId"]

    #... Fetching the gauge details from the gauge details json files in the datahub ...#
    gauge_details_file_paths = glob.glob(os.path.join(json_details_path, 'gauge_details_*.json'))
    if gauge_details_file_paths == []:
        return None
    try:
        # .. Reading all the gauge details JSON files ..#
        gauge_details_jsons = list(
            map(lambda x: json.load(open(x)), gauge_details_file_paths))
        # .. Choosing the gauge details JSON for the current Input JSON Data by comparing the machine ids in Input and gauge details JSONs ..#
        gauge_details_json = list(filter(
            lambda x: x['id'] == machine_id, gauge_details_jsons))[0]
        gauge_rule_list = Gauge_Rule_Extraction(
            gauge_details_json)['gauge_rule_list']
        return gauge_rule_list
    except:
        gauge_rule_list = None

    return gauge_rule_list


