"""
[-] Title: PUMP COMPUTATION
[~] Build: v2.0
[+] Author: Biprodeep Roy
[>] Licensed to: MachineSense™
[~] Description: This application retrives the raw data from critical process and processes it for pumpsense-analytics.
[~] Execute Command: python3 pump-computation.py -c /tmp/pumpsense-compute.json
"""

from pynovatec.events import EventListener,EventRegisterListener,EventPost,EventUnregisterListener, EventQueueShutdown
from machineqc_events import MachineQCListener

from qc_compute import  MachineQC,MachineQCThread
import pump_analytics
import sys
import getopt
import time
import threading

data_interval=120

config = {
            'CONFIG_FILE_PATH': '/var/r_config.json',
            'JSON_DATA_FOLDER_PATH': '/var/json_data',
            'CONF_FOLDER_PATH': '/usr/src/conf',
            'STORED_OBJECTS':'/home/pi/pumpsense_computation/stored_objects',
            'stored_objects_dir':'/home/pi/pumpsense_computation/stored_objects',
            'ANALYTICS_ERROR_LOG':'/home/pi/pumpsense_computation/reason_log.json',
            'INPUT_JSON_FOLDER_PATH':'/home/pi/pumpsense_computation/INPUT JSON',
            'OUTPUT_JSON_FOLDER_PATH':'/home/pi/pumpsense_computation/OUTPUT JSON',
            'bridge_data_path':'/home/pi/ramcsv/',
            'machine_filepath':'/var/json_data/machine_details_0.json',
            'send_input_json': False,
            'json_details_path': '/opt/novatec/slave/json_data',
            'working_dir': '/tmp/qc_computation',
            'log_file': '/tmp/qc/log/reason_log.json',
            'config_path': "/tmp/qc/conf/r_config.json",
            'conf_dir': "/tmp/qc/conf",
            'json_sender_port': "4445"
}

def show_threads(msg=None):
    if msg:
        print(msg)

    threads = threading.enumerate()
    for thread in threads:
        print("t: ",thread.name)

batcher='zmq'

try:
    opts, args = getopt.getopt(sys.argv[1:],"c:F:i:b:")
    #print("opts is: ",opts)
except getopt.GetoptError:
    print("Error: Error Loading Configuration Details: ")
for opt,arg in opts:
    #print("opt is: ",opt)
    if opt == "-c":
        config_file = arg
    if opt == "-F":
        csvFormat = int(arg)
    if opt == "-i":
        data_interval = int(arg)
    if opt == "-b":
        batcher = arg

print("args: ",args)

config = pump_analytics.read_config(config_file,config)


EventRegisterListener(MachineQCListener())
mqc = MachineQCThread(config,batcher=batcher)
mqc.start()
time.sleep(1)
show_threads("After first start")
print("***************** SLEEPING ******************************")
time.sleep(80)
print("************* STOPPING **********************")
mqc.stop()
print("************* Joining *******************")
mqc.join()

mqc = None
show_threads("After first shutdown")

print("*************** Creating new ************************")
mqc = MachineQCThread(config,interval=data_interval,batcher=batcher)
print("*************** Starting new ************************")
mqc.start()
time.sleep(1)
show_threads("After second start")
print("*************** Joining new ************************")
mqc.join()

#start_machine_qc(config)

print("start_machine_qc ended..")
EventQueueShutdown()



